diff --git a/gcc/compare-elim.c b/gcc/compare-elim.c
index 367cd8e..7fe0728 100644
--- a/gcc/compare-elim.c
+++ b/gcc/compare-elim.c
@@ -651,24 +651,34 @@ gate_compare_elim_after_reload (void)
   return flag_compare_elim_after_reload;
 }
 
-struct rtl_opt_pass pass_compare_elim_after_reload =
+class pass_compare_elim_after_reload : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cmpelim",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_compare_elim_after_reload,	/* gate */
-  execute_compare_elim_after_reload,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_df_finish
-  | TODO_df_verify
-  | TODO_verify_rtl_sharing		/* todo_flags_finish */
- }
-};
+public:
+  pass_compare_elim_after_reload(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cmpelim",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_df_verify | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_compare_elim_after_reload (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_compare_elim_after_reload ();
+  }
+
+}; // class pass_compare_elim_after_reload
+
+rtl_opt_pass *
+make_pass_compare_elim_after_reload (context &ctxt)
+{
+  return new pass_compare_elim_after_reload (ctxt);
+}
diff --git a/gcc/config/epiphany/epiphany.h b/gcc/config/epiphany/epiphany.h
index 1e5c305..e776b7d 100644
--- a/gcc/config/epiphany/epiphany.h
+++ b/gcc/config/epiphany/epiphany.h
@@ -926,8 +926,8 @@ enum
 };
 
 extern int epiphany_normal_fp_rounding;
-extern struct rtl_opt_pass pass_mode_switch_use;
-extern struct rtl_opt_pass pass_resolve_sw_modes;
+extern rtl_opt_pass *make_pass_mode_switch_use (context &ctxt);
+extern rtl_opt_pass *make_pass_resolve_sw_modes (context &ctxt);
 
 /* This will need to be adjusted when FP_CONTRACT_ON is properly
    implemented.  */
diff --git a/gcc/config/epiphany/mode-switch-use.c b/gcc/config/epiphany/mode-switch-use.c
index 6652963..3de7028 100644
--- a/gcc/config/epiphany/mode-switch-use.c
+++ b/gcc/config/epiphany/mode-switch-use.c
@@ -71,22 +71,32 @@ insert_uses (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_mode_switch_use =
+class pass_mode_switch_use : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "mode_switch_use",			/* name */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  NULL,					/* gate */
-  insert_uses,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0,					/* todo_flags_finish */
- }
-};
+public:
+  pass_mode_switch_use(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "mode_switch_use",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return insert_uses (); }
+
+}; // class pass_mode_switch_use
+
+rtl_opt_pass *
+make_pass_mode_switch_use (context &ctxt)
+{
+  return new pass_mode_switch_use (ctxt);
+}
diff --git a/gcc/config/epiphany/resolve-sw-modes.c b/gcc/config/epiphany/resolve-sw-modes.c
index 729a0ff..cfe881c 100644
--- a/gcc/config/epiphany/resolve-sw-modes.c
+++ b/gcc/config/epiphany/resolve-sw-modes.c
@@ -161,23 +161,32 @@ resolve_sw_modes (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_resolve_sw_modes =
+class pass_resolve_sw_modes : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "resolve_sw_modes",			/* name */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  gate_resolve_sw_modes,		/* gate */
-  resolve_sw_modes,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_MODE_SWITCH,			/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_resolve_sw_modes(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "resolve_sw_modes",
+		   OPTGROUP_NONE,
+		   TV_MODE_SWITCH,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_resolve_sw_modes (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return resolve_sw_modes (); }
+
+}; // class pass_resolve_sw_modes
+
+rtl_opt_pass *
+make_pass_resolve_sw_modes (context &ctxt)
+{
+  return new pass_resolve_sw_modes (ctxt);
+}
diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index c365e2c..1beed80 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -2516,26 +2516,37 @@ rest_of_handle_insert_vzeroupper (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_insert_vzeroupper =
+class pass_insert_vzeroupper : public rtl_opt_pass
+{
+public:
+  pass_insert_vzeroupper(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "vzeroupper",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_insert_vzeroupper (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_insert_vzeroupper ();
+  }
+
+}; // class pass_insert_vzeroupper
+
+rtl_opt_pass *
+make_pass_insert_vzeroupper (context &ctxt)
 {
- {
-  RTL_PASS,
-  "vzeroupper",				/* name */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  gate_insert_vzeroupper,		/* gate */
-  rest_of_handle_insert_vzeroupper,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0,					/* todo_flags_finish */
- }
-};
+  return new pass_insert_vzeroupper (ctxt);
+}
 
 /* Return true if a red-zone is in use.  */
 
diff --git a/gcc/config/sparc/sparc.c b/gcc/config/sparc/sparc.c
index 1dc4e36..98d0236 100644
--- a/gcc/config/sparc/sparc.c
+++ b/gcc/config/sparc/sparc.c
@@ -906,25 +906,35 @@ sparc_do_work_around_errata (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_work_around_errata =
-{
- {
-  RTL_PASS,
-  "errata",				/* name */
-  OPTGROUP_NONE,			/* optinfo_flags */
-  sparc_gate_work_around_errata,	/* gate */
-  sparc_do_work_around_errata,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_MACH_DEP,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_rtl_sharing,		/* todo_flags_finish */
- }
-};
+class pass_work_around_errata : public rtl_opt_pass
+{
+public:
+  pass_work_around_errata(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "errata",
+		   OPTGROUP_NONE,
+		   TV_MACH_DEP,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return sparc_gate_work_around_errata (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return sparc_do_work_around_errata (); }
+
+}; // class pass_work_around_errata
+
+rtl_opt_pass *
+make_pass_work_around_errata (context &ctxt)
+{
+  return new pass_work_around_errata (ctxt);
+}
 
 struct register_pass_info insert_pass_work_around_errata =
 {
diff --git a/gcc/cprop.c b/gcc/cprop.c
index 6a6b5f1..1727482 100644
--- a/gcc/cprop.c
+++ b/gcc/cprop.c
@@ -1913,23 +1913,32 @@ execute_rtl_cprop (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_rtl_cprop =
+class pass_rtl_cprop : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cprop",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_rtl_cprop,                       /* gate */
-  execute_rtl_cprop,  			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CPROP,                             /* tv_id */
-  PROP_cfglayout,                       /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_rtl_cprop(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cprop",
+		   OPTGROUP_NONE,
+		   TV_CPROP,
+		   pass_properties(required(PROP_cfglayout),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rtl_cprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_rtl_cprop (); }
+
+}; // class pass_rtl_cprop
+
+rtl_opt_pass *
+make_pass_rtl_cprop (context &ctxt)
+{
+  return new pass_rtl_cprop (ctxt);
+}
diff --git a/gcc/cse.c b/gcc/cse.c
index f2c8f63..db19b81 100644
--- a/gcc/cse.c
+++ b/gcc/cse.c
@@ -7449,26 +7449,35 @@ rest_of_handle_cse (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_cse =
+class pass_cse : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cse1",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_cse,                      /* gate */
-  rest_of_handle_cse,			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CSE,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_cse(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cse1",
+		   OPTGROUP_NONE,
+		   TV_CSE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_cse (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_cse (); }
+
+}; // class pass_cse
+
+rtl_opt_pass *
+make_pass_cse (context &ctxt)
+{
+  return new pass_cse (ctxt);
+}
 
 
 static bool
@@ -7511,26 +7520,35 @@ rest_of_handle_cse2 (void)
 }
 
 
-struct rtl_opt_pass pass_cse2 =
+class pass_cse2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cse2",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_cse2,                     /* gate */
-  rest_of_handle_cse2,			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CSE2,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_cse2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cse2",
+		   OPTGROUP_NONE,
+		   TV_CSE2,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_cse2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_cse2 (); }
+
+}; // class pass_cse2
+
+rtl_opt_pass *
+make_pass_cse2 (context &ctxt)
+{
+  return new pass_cse2 (ctxt);
+}
 
 static bool
 gate_handle_cse_after_global_opts (void)
@@ -7571,23 +7589,34 @@ rest_of_handle_cse_after_global_opts (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_cse_after_global_opts =
+class pass_cse_after_global_opts : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "cse_local",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_cse_after_global_opts,    /* gate */
-  rest_of_handle_cse_after_global_opts, /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_CSE,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+public:
+  pass_cse_after_global_opts(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "cse_local",
+		   OPTGROUP_NONE,
+		   TV_CSE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_cse_after_global_opts (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_cse_after_global_opts ();
+  }
+
+}; // class pass_cse_after_global_opts
+
+rtl_opt_pass *
+make_pass_cse_after_global_opts (context &ctxt)
+{
+  return new pass_cse_after_global_opts (ctxt);
+}
diff --git a/gcc/dce.c b/gcc/dce.c
index 64ed81e..62d36a1 100644
--- a/gcc/dce.c
+++ b/gcc/dce.c
@@ -786,25 +786,35 @@ gate_ud_dce (void)
     && dbg_cnt (dce_ud);
 }
 
-struct rtl_opt_pass pass_ud_rtl_dce =
+class pass_ud_rtl_dce : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "ud_dce",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_ud_dce,                          /* gate */
-  rest_of_handle_ud_dce,                /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DCE,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_ud_rtl_dce(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "ud_dce",
+		   OPTGROUP_NONE,
+		   TV_DCE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ud_dce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_ud_dce (); }
+
+}; // class pass_ud_rtl_dce
+
+rtl_opt_pass *
+make_pass_ud_rtl_dce (context &ctxt)
+{
+  return new pass_ud_rtl_dce (ctxt);
+}
 
 
 /* -------------------------------------------------------------------------
@@ -1201,22 +1211,32 @@ gate_fast_dce (void)
     && dbg_cnt (dce_fast);
 }
 
-struct rtl_opt_pass pass_fast_rtl_dce =
+class pass_fast_rtl_dce : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "rtl_dce",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_fast_dce,                        /* gate */
-  rest_of_handle_fast_dce,              /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DCE,                               /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+public:
+  pass_fast_rtl_dce(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "rtl_dce",
+		   OPTGROUP_NONE,
+		   TV_DCE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_fast_dce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_fast_dce (); }
+
+}; // class pass_fast_rtl_dce
+
+rtl_opt_pass *
+make_pass_fast_rtl_dce (context &ctxt)
+{
+  return new pass_fast_rtl_dce (ctxt);
+}
diff --git a/gcc/df-core.c b/gcc/df-core.c
index e602290..b3cfa2f 100644
--- a/gcc/df-core.c
+++ b/gcc/df-core.c
@@ -746,25 +746,35 @@ gate_opt (void)
 }
 
 
-struct rtl_opt_pass pass_df_initialize_opt =
-{
- {
-  RTL_PASS,
-  "dfinit",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_opt,                             /* gate */
-  rest_of_handle_df_initialize,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DF_SCAN,                           /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_df_initialize_opt : public rtl_opt_pass
+{
+public:
+  pass_df_initialize_opt(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dfinit",
+		   OPTGROUP_NONE,
+		   TV_DF_SCAN,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_opt (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_df_initialize (); }
+
+}; // class pass_df_initialize_opt
+
+rtl_opt_pass *
+make_pass_df_initialize_opt (context &ctxt)
+{
+  return new pass_df_initialize_opt (ctxt);
+}
 
 
 static bool
@@ -774,25 +784,35 @@ gate_no_opt (void)
 }
 
 
-struct rtl_opt_pass pass_df_initialize_no_opt =
+class pass_df_initialize_no_opt : public rtl_opt_pass
+{
+public:
+  pass_df_initialize_no_opt(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "no-opt dfinit",
+		   OPTGROUP_NONE,
+		   TV_DF_SCAN,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_no_opt (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_df_initialize (); }
+
+}; // class pass_df_initialize_no_opt
+
+rtl_opt_pass *
+make_pass_df_initialize_no_opt (context &ctxt)
 {
- {
-  RTL_PASS,
-  "no-opt dfinit",                      /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_no_opt,                          /* gate */
-  rest_of_handle_df_initialize,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DF_SCAN,                           /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+  return new pass_df_initialize_no_opt (ctxt);
+}
 
 
 /* Free all the dataflow info and the DF structure.  This should be
@@ -822,25 +842,35 @@ rest_of_handle_df_finish (void)
 }
 
 
-struct rtl_opt_pass pass_df_finish =
-{
- {
-  RTL_PASS,
-  "dfinish",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  rest_of_handle_df_finish,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_df_finish : public rtl_opt_pass
+{
+public:
+  pass_df_finish(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dfinish",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_df_finish (); }
+
+}; // class pass_df_finish
+
+rtl_opt_pass *
+make_pass_df_finish (context &ctxt)
+{
+  return new pass_df_finish (ctxt);
+}
 
 
 
diff --git a/gcc/dse.c b/gcc/dse.c
index d643cb0..efc228f 100644
--- a/gcc/dse.c
+++ b/gcc/dse.c
@@ -3729,42 +3729,62 @@ gate_dse2 (void)
     && dbg_cnt (dse2);
 }
 
-struct rtl_opt_pass pass_rtl_dse1 =
-{
- {
-  RTL_PASS,
-  "dse1",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dse1,                            /* gate */
-  rest_of_handle_dse,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DSE1,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+class pass_rtl_dse1 : public rtl_opt_pass
+{
+public:
+  pass_rtl_dse1(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dse1",
+		   OPTGROUP_NONE,
+		   TV_DSE1,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dse1 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_dse (); }
+
+}; // class pass_rtl_dse1
+
+rtl_opt_pass *
+make_pass_rtl_dse1 (context &ctxt)
+{
+  return new pass_rtl_dse1 (ctxt);
+}
 
-struct rtl_opt_pass pass_rtl_dse2 =
-{
- {
-  RTL_PASS,
-  "dse2",                               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dse2,                            /* gate */
-  rest_of_handle_dse,                   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_DSE2,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing /* todo_flags_finish */
- }
-};
+class pass_rtl_dse2 : public rtl_opt_pass
+{
+public:
+  pass_rtl_dse2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dse2",
+		   OPTGROUP_NONE,
+		   TV_DSE2,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dse2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_dse (); }
+
+}; // class pass_rtl_dse2
+
+rtl_opt_pass *
+make_pass_rtl_dse2 (context &ctxt)
+{
+  return new pass_rtl_dse2 (ctxt);
+}
diff --git a/gcc/dwarf2cfi.c b/gcc/dwarf2cfi.c
index 9f0a594..c84d5c5 100644
--- a/gcc/dwarf2cfi.c
+++ b/gcc/dwarf2cfi.c
@@ -3365,24 +3365,34 @@ gate_dwarf2_frame (void)
   return dwarf2out_do_frame ();
 }
 
-struct rtl_opt_pass pass_dwarf2_frame =
-{
- {
-  RTL_PASS,
-  "dwarf2",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_dwarf2_frame,		/* gate */
-  execute_dwarf2_frame,		/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_FINAL,			/* tv_id */
-  0,				/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  0				/* todo_flags_finish */
- }
-};
+class pass_dwarf2_frame : public rtl_opt_pass
+{
+public:
+  pass_dwarf2_frame(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "dwarf2",
+		   OPTGROUP_NONE,
+		   TV_FINAL,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dwarf2_frame (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_dwarf2_frame (); }
+
+}; // class pass_dwarf2_frame
+
+rtl_opt_pass *
+make_pass_dwarf2_frame (context &ctxt)
+{
+  return new pass_dwarf2_frame (ctxt);
+}
 
 #include "gt-dwarf2cfi.h"
diff --git a/gcc/except.c b/gcc/except.c
index 4e85f73..f94008f 100644
--- a/gcc/except.c
+++ b/gcc/except.c
@@ -1949,25 +1949,35 @@ set_nothrow_function_flags (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_set_nothrow_function_flags =
-{
- {
-  RTL_PASS,
-  "nothrow",                            /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  set_nothrow_function_flags,           /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_set_nothrow_function_flags : public rtl_opt_pass
+{
+public:
+  pass_set_nothrow_function_flags(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "nothrow",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return set_nothrow_function_flags (); }
+
+}; // class pass_set_nothrow_function_flags
+
+rtl_opt_pass *
+make_pass_set_nothrow_function_flags (context &ctxt)
+{
+  return new pass_set_nothrow_function_flags (ctxt);
+}
 
 
 /* Various hooks for unwind library.  */
@@ -2596,25 +2606,35 @@ gate_convert_to_eh_region_ranges (void)
   return true;
 }
 
-struct rtl_opt_pass pass_convert_to_eh_region_ranges =
-{
- {
-  RTL_PASS,
-  "eh_ranges",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_convert_to_eh_region_ranges,	/* gate */
-  convert_to_eh_region_ranges,          /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0              			/* todo_flags_finish */
- }
-};
+class pass_convert_to_eh_region_ranges : public rtl_opt_pass
+{
+public:
+  pass_convert_to_eh_region_ranges(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "eh_ranges",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_convert_to_eh_region_ranges (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return convert_to_eh_region_ranges (); }
+
+}; // class pass_convert_to_eh_region_ranges
+
+rtl_opt_pass *
+make_pass_convert_to_eh_region_ranges (context &ctxt)
+{
+  return new pass_convert_to_eh_region_ranges (ctxt);
+}
 
 static void
 push_uleb128 (vec<uchar, va_gc> **data_area, unsigned int value)
